#!/usr/bin/perl

use strict;
use warnings;

use SOAP::Lite +trace => 'debug';
use MIME::Base64;

my $site = 'http://bp4smdemo.hpsweducation.com:13080/SM/7';
my $user = 'falcon';
my $password = 'orange perfection';
my $auth = encode_base64("$user:$password", '');

my $soap = SOAP::Lite->new(
    proxy => "$site/ws",
    service => "$site/ConfigurationManagement.wsdl",
    default_ns => $site);
$soap->transport->http_request->header('Authorization' => "Basic $auth");
$soap->on_action(sub { '"RetrieveKeysList"'; } );

my $keys = SOAP::Data->name('keys' => '')->type('');
my $instance = SOAP::Data->name('instance' => '')->type('');
my $model = SOAP::Data->name('model' => \SOAP::Data->value($keys, $instance));
my $som = $soap->call('RetrieveContactKeysList', $model);

if ($som->fault) {
    my $code = $som->faultcode;
    my $actor = $som->faultactor;
    my $string = $som->faultstring;
    my $detail = $som->faultdetail;
    my $out = "Fault\n";
    $out .= "\tCode\t$code\n" if ($code);
    $out .= "\tActor\t$actor\n" if ($actor);
    $out .= "\tString\t$string\n" if ($string);
    $out .= "\tDetail\t$detail\n" if ($detail);
    die $out;
}

soapdata('//RetrieveContactKeysListResponse/keys', 1);
soapdata('//RetrieveContactKeysListResponse/model', 0);
soapdata('//RetrieveContactKeysListResponse/messages', 1);

sub soapdata {
    my ($root, $num) = @_;
    my $ref = $som->valueof($root);
    my @keys = sort(keys(%$ref));
    foreach my $k (@keys) {
	my $count = 0;
	foreach my $v ($som->valueof("$root/$k")) {
	    my $kk = $k;
	    $count += 1;
	    if (! defined $v) {
		$kk .= "[$count]" if ($num);
		print "$kk: (undefined)\n";
	    } elsif ($v =~ m/^HASH\(.*\)$/) {
		soapdata("$root/$k", 1);
	    } elsif ($v eq '') {
		$kk .= "[$count]" if ($num);
		print "$kk: (empty)\n";
	    } else {
		$kk .= "[$count]" if ($num);
		my @ls = split(/\n/, $v);
		my $lcount = 0;
		foreach my $l (@ls) {
		    $lcount += 1;
		    $kk .= "($lcount)" if ($#ls > 0);
		    print "$kk: $l\n";
		}
	    }
	}
    }
}
